searchData={"items":[{"type":"module","title":"OtelTelemetryMetrics","doc":"BASED ON THIS PR:\nhttps://github.com/open-telemetry/opentelemetry-erlang-contrib/pull/303\n\nIf we can get this generally working, it would be nice to contribute the changes back.\n\n`OtelTelemetryMetrics.start_link/1` creates OpenTelemetry Instruments for\n`Telemetry.Metric` metrics and records to them when their corresponding\nevents are triggered.\n\n    metrics = [\n      last_value(\"vm.memory.binary\", unit: :byte),\n      counter(\"vm.memory.total\"),\n      counter(\"db.query.duration\", tags: [:table, :operation]),\n      summary(\"http.request.response_time\",\n        tag_values: fn\n          %{foo: :bar} -> %{bar: :baz}\n        end,\n        tags: [:bar],\n        drop: fn metadata ->\n          metadata[:boom] == :pow\n        end\n      ),\n      sum(\"telemetry.event_size.metadata\",\n        measurement: &__MODULE__.metadata_measurement/2\n      ),\n      distribution(\"phoenix.endpoint.stop.duration\",\n        measurement: &__MODULE__.measurement/1\n      )\n    ]\n\n    {:ok, _} = OtelTelemetryMetrics.start_link([metrics: metrics])\n\nThen either in your Application code or a dependency execute `telemetry`\nevents conataining the measurements. For example, an event that will result\nin the metrics `vm.memory.total` and `vm.memory.binary` being recorded to:\n\n    :telemetry.execute([:vm, :memory], %{binary: 100, total: 200}, %{})\n\nOpenTelemetry does not support a `summary` type metric, the `summary`\n`http.request.response_time` is recorded as a single bucket histogram.\n\nIn `Telemetry.Metrics` the `counter` type refers to counting the number of\ntimes an event is triggered, this is represented as a `sum` in OpenTelemetry\nand when recording the value is sent as a `1` every time.\n\nMetrics of type `last_value` are ignored because `last_value` is not yet an\naggregation supported on synchronous instruments in Erlang/Elixir\nOpenTelemetry. When it is added to the SDK this library will be updated to\nno longer ignore metrics of this type.","ref":"OtelTelemetryMetrics.html"},{"type":"function","title":"OtelTelemetryMetrics.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"OtelTelemetryMetrics.html#child_spec/1"},{"type":"function","title":"OtelTelemetryMetrics.handle_event/4","doc":"","ref":"OtelTelemetryMetrics.html#handle_event/4"},{"type":"function","title":"OtelTelemetryMetrics.start_link/1","doc":"","ref":"OtelTelemetryMetrics.html#start_link/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}